import Head from "next/head";
import Image from "next/image";
import { useState } from "react";
import styles from "../styles/Home.module.css";

function Wrapper({ children, total, index }) {
    if (index >= total) {
        return children;
    }

    if (!index) index = 0;

    return (
        <div>
            <Wrapper total={total} index={index + 1}>
                {children}
            </Wrapper>
        </div>
    );
}

export default function Home() {
    const [title, setTitle] = useState("yellow");
    return (
        <div className={styles.container}>
            <Head>
                <title>Create Next App</title>
                <meta
                    name="description"
                    content="Generated by create next app"
                />
                <link rel="icon" href="/favicon.ico" />
            </Head>

            <main className={styles.main}>
                <Wrapper total={20} index={0}>
                    <h1>Text in Wrapper</h1>
                    <button
                        style={{
                            backgroundColor: title,
                        }}
                        onClick={async () => {
                            const resp = await fetch("/api/hello", {
                                method: "POST",
                                body: JSON.stringify({
                                    id: "123",
                                }),
                                "Content-Type": "application/json",
                            });
                            const json = await resp.json();
                            setTitle(json.color);
                        }}
                    >
                        {title}
                    </button>
                    title
                </Wrapper>
            </main>

            <footer className={styles.footer}>
                <a
                    href="https://vercel.com?utm_source=create-next-app&utm_medium=default-template&utm_campaign=create-next-app"
                    target="_blank"
                    rel="noopener noreferrer"
                >
                    Powered by{" "}
                    <span className={styles.logo}>
                        <Image
                            src="/vercel.svg"
                            alt="Vercel Logo"
                            width={72}
                            height={16}
                        />
                    </span>
                </a>
            </footer>
        </div>
    );
}
